/// AUTO GENERATED BY build.rs

use std::collections::HashMap;

use webrender_build::shader::ShaderVersion;

pub struct SourceWithDigest {
    pub source: &'static str,
    pub digest: &'static str,
}

pub struct OptimizedSourceWithDigest {
    pub vert_source: &'static str,
    pub frag_source: &'static str,
    pub digest: &'static str,
}

lazy_static! {
  pub static ref UNOPTIMIZED_SHADERS: HashMap<&'static str, SourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert("base", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/base.glsl"), digest: "b9cce220af80cc2d"});
    shaders.insert("blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/blend.glsl"), digest: "1c6f6f2578877c93"});
    shaders.insert("brush", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/brush.glsl"), digest: "6d58de6f1400f9c8"});
    shaders.insert("brush_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/brush_blend.glsl"), digest: "7b05da9538aeb6fe"});
    shaders.insert("brush_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/brush_image.glsl"), digest: "f95e73242d329a0b"});
    shaders.insert("brush_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/brush_linear_gradient.glsl"), digest: "37ff6a03f8dad8f0"});
    shaders.insert("brush_mix_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/brush_mix_blend.glsl"), digest: "2a79d724a159ad94"});
    shaders.insert("brush_opacity", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/brush_opacity.glsl"), digest: "d41989844b8f45bb"});
    shaders.insert("brush_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/brush_solid.glsl"), digest: "75452b39e6bb63eb"});
    shaders.insert("brush_yuv_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/brush_yuv_image.glsl"), digest: "a8a26cbcdc9890ba"});
    shaders.insert("clip_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/clip_shared.glsl"), digest: "e8e30ba2163cfdc4"});
    shaders.insert("composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/composite.glsl"), digest: "70432076dfcb0c1b"});
    shaders.insert("cs_blur", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_blur.glsl"), digest: "8897cd110b15c780"});
    shaders.insert("cs_border_segment", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_border_segment.glsl"), digest: "2a7061184e4d0a17"});
    shaders.insert("cs_border_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_border_solid.glsl"), digest: "521c1d39c155be63"});
    shaders.insert("cs_clip_box_shadow", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_clip_box_shadow.glsl"), digest: "f283831610dcec7b"});
    shaders.insert("cs_clip_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_clip_image.glsl"), digest: "39a5236d1f41fb7a"});
    shaders.insert("cs_clip_rectangle", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_clip_rectangle.glsl"), digest: "a3482069bfb4d8ba"});
    shaders.insert("cs_conic_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_conic_gradient.glsl"), digest: "54d3bfe79fa58d17"});
    shaders.insert("cs_fast_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_fast_linear_gradient.glsl"), digest: "344f1e0de1fa4904"});
    shaders.insert("cs_line_decoration", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_line_decoration.glsl"), digest: "1d7cbc18b97da1be"});
    shaders.insert("cs_radial_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_radial_gradient.glsl"), digest: "595598bcf40ae01e"});
    shaders.insert("cs_scale", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_scale.glsl"), digest: "c1f755cd869231e3"});
    shaders.insert("cs_svg_filter", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/cs_svg_filter.glsl"), digest: "832efbc00bbf08fd"});
    shaders.insert("debug_color", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/debug_color.glsl"), digest: "58d1aaa3a0cd3100"});
    shaders.insert("debug_font", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/debug_font.glsl"), digest: "42f530db0b7c5880"});
    shaders.insert("ellipse", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/ellipse.glsl"), digest: "1883f224293b6515"});
    shaders.insert("gpu_cache", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/gpu_cache.glsl"), digest: "e99b57d9cc26406a"});
    shaders.insert("gpu_cache_update", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/gpu_cache_update.glsl"), digest: "e5a4b7aea770a2f2"});
    shaders.insert("gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/gradient.glsl"), digest: "d27b0ffe1e6af869"});
    shaders.insert("gradient_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/gradient_shared.glsl"), digest: "f22f798f633b116a"});
    shaders.insert("pf_vector_cover", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/pf_vector_cover.glsl"), digest: "e7bffadf531314e9"});
    shaders.insert("pf_vector_stencil", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/pf_vector_stencil.glsl"), digest: "9d018cb74afe56b4"});
    shaders.insert("prim_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/prim_shared.glsl"), digest: "b463d3f867269c9f"});
    shaders.insert("ps_clear", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/ps_clear.glsl"), digest: "2a1d25691da29697"});
    shaders.insert("ps_split_composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/ps_split_composite.glsl"), digest: "32d2fe4994e95231"});
    shaders.insert("ps_text_run", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/ps_text_run.glsl"), digest: "be3611c1cc4388db"});
    shaders.insert("rect", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/rect.glsl"), digest: "8792120018f5d840"});
    shaders.insert("render_task", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/render_task.glsl"), digest: "3e16cd6b386f9247"});
    shaders.insert("shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/shared.glsl"), digest: "aad82ac8b32e61f7"});
    shaders.insert("shared_other", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/shared_other.glsl"), digest: "9f6298a27dfe79c6"});
    shaders.insert("transform", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/transform.glsl"), digest: "c783752dc8c02e55"});
    shaders.insert("yuv", SourceWithDigest { source: include_str!("/builddir/build/BUILD/firefox-89.0.2/gfx/wr/webrender/res/yuv.glsl"), digest: "853c9a9da7e60b91"});
    shaders
  };

  pub static ref OPTIMIZED_SHADERS: HashMap<(ShaderVersion, &'static str), OptimizedSourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert((ShaderVersion::Gl, "brush_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_blend_Gl.frag"),
        digest: "b306b512ef2102b4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_blend_ALPHA_PASS_Gl.frag"),
        digest: "22d2be5d731d0ba",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "940d061301664d73",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "6f9dced39f0b13f9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "7649ac4f541cc1b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "224fcf73ab6eb67d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "c5310ae85f6ae657",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "88d8770e47a77f97",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "1ce96249ce75006d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "f05ff9df39f990ae",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "ff35d4703606ef68",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "e16f7fdb10aad57b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.frag"),
        digest: "45b8c31ce141ee41",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "823cb6dd0fdb6a45",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "f82214cd7dace5f9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "1dfb0184dbb821ce",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "55c095e0be95e770",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "a1ea9c73cc8048d8",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "335796bd6788d72b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "c4999fd4985f5f38",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.frag"),
        digest: "b9b2387e4d6f083c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_TEXTURE_2D_Gl.frag"),
        digest: "7fe2192a54c42946",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_image_TEXTURE_RECT_Gl.frag"),
        digest: "9efcd553bb3b51e5",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_linear_gradient_Gl.frag"),
        digest: "565ee92b6b17dcd6",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_linear_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_linear_gradient_ALPHA_PASS_Gl.frag"),
        digest: "4768277bbe570377",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "37d3269a7a4f57e7",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_mix_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_mix_blend_Gl.frag"),
        digest: "ffebb293f58e3c08",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_mix_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_mix_blend_ALPHA_PASS_Gl.frag"),
        digest: "ddf57ac6b26ea26e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "3e4e13e79a4a6526",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_Gl.frag"),
        digest: "b25b6f587b6961af",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_ALPHA_PASS_Gl.frag"),
        digest: "45a5d6332a8cd760",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.frag"),
        digest: "ee3b0617386837ee",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_ANTIALIASING_Gl.frag"),
        digest: "b16b6ab1af345e07",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.frag"),
        digest: "7016cfca68469260",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_opacity_DEBUG_OVERDRAW_Gl.frag"),
        digest: "45edc8b14180e9c2",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_solid_Gl.frag"),
        digest: "4a827284ee9bdd9f",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_solid_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_solid_ALPHA_PASS_Gl.frag"),
        digest: "9134a713653a9fa",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_solid_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_solid_DEBUG_OVERDRAW_Gl.frag"),
        digest: "dd6868af2ff8e713",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.frag"),
        digest: "94929ad577709702",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "52568cf58a421b07",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.frag"),
        digest: "e927ff3ed7b82fdd",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "e3f46a5e5eb2a439",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.frag"),
        digest: "6052f0808dd035",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "2ce9620e8b841290",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_FAST_PATH_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_FAST_PATH_TEXTURE_2D_Gl.frag"),
        digest: "cd5856a5b6626fea",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_FAST_PATH_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_FAST_PATH_TEXTURE_RECT_Gl.frag"),
        digest: "6bb6b51c7c2f1392",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_TEXTURE_2D_Gl.frag"),
        digest: "541058407169cf49",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_TEXTURE_2D_YUV_Gl.frag"),
        digest: "e8e89c7ab5cc8b5b",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_TEXTURE_RECT_Gl.frag"),
        digest: "17ec7442a2e6c8da",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/composite_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "9bc1da4d9f3b4fdb",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_ALPHA_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_blur_ALPHA_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_blur_ALPHA_TARGET_Gl.frag"),
        digest: "d7607a4c0138637d",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_COLOR_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_blur_COLOR_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_blur_COLOR_TARGET_Gl.frag"),
        digest: "5251c9553f50adb8",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_segment"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_border_segment_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_border_segment_Gl.frag"),
        digest: "ba5887be98840bb8",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_border_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_border_solid_Gl.frag"),
        digest: "f2e98082d291c2df",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_box_shadow_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_clip_box_shadow_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_clip_box_shadow_TEXTURE_2D_Gl.frag"),
        digest: "3084e46d4d0a0355",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_clip_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_clip_image_TEXTURE_2D_Gl.frag"),
        digest: "f8742cd2f67ed001",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_clip_rectangle_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_clip_rectangle_Gl.frag"),
        digest: "2bacb8685741e60f",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_clip_rectangle_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_clip_rectangle_FAST_PATH_Gl.frag"),
        digest: "ef6361a61d3512d6",
    });
    shaders.insert((ShaderVersion::Gl, "cs_conic_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_conic_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_conic_gradient_Gl.frag"),
        digest: "1f664db490ae4b78",
    });
    shaders.insert((ShaderVersion::Gl, "cs_fast_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_fast_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_fast_linear_gradient_Gl.frag"),
        digest: "e42103ea32ffa5d2",
    });
    shaders.insert((ShaderVersion::Gl, "cs_line_decoration"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_line_decoration_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_line_decoration_Gl.frag"),
        digest: "b727ce6ac2c3c231",
    });
    shaders.insert((ShaderVersion::Gl, "cs_radial_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_radial_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_radial_gradient_Gl.frag"),
        digest: "66a8b5c31ba1f3ad",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_scale_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_scale_TEXTURE_2D_Gl.frag"),
        digest: "3951d0499251493c",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_scale_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_scale_TEXTURE_RECT_Gl.frag"),
        digest: "e8efead3fb714c6e",
    });
    shaders.insert((ShaderVersion::Gl, "cs_svg_filter"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_svg_filter_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/cs_svg_filter_Gl.frag"),
        digest: "ffccf5fc51d9dba",
    });
    shaders.insert((ShaderVersion::Gl, "debug_color"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/debug_color_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/debug_color_Gl.frag"),
        digest: "f458fe7ea40bd77e",
    });
    shaders.insert((ShaderVersion::Gl, "debug_font"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/debug_font_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/debug_font_Gl.frag"),
        digest: "503ec56c19b6bd2c",
    });
    shaders.insert((ShaderVersion::Gl, "ps_clear"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_clear_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_clear_Gl.frag"),
        digest: "e696a5e94c11171b",
    });
    shaders.insert((ShaderVersion::Gl, "ps_split_composite"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_split_composite_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_split_composite_Gl.frag"),
        digest: "aade82fab7ac9215",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "c1a26314c7cbb181",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "b9517aa99f4f086d",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "43ade4836d3e1675",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "61e09ed591327144",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "6280c2679b7bd998",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/firefox-89.0.2/objdir/x86_64-unknown-linux-gnu/release/build/webrender-13d25dacd0bc1ced/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "fe59bc92f19bd089",
    });
    shaders
  };
}
